
#include <windows.h>  
#include <stdio.h>
#include "ParmOpts.h"
#include "sqlext.h"  


#if defined (WIN32)
	#define IS_WIN32 TRUE
#else
	#define IS_WIN32 FALSE
#endif

#define IS_NT      IS_WIN32 && (BOOL)(GetVersion() < 0x80000000)
#define IS_WIN32S  IS_WIN32 && (BOOL)(!(IS_NT) && (LOBYTE(LOWORD(GetVersion()))<4))
#define IS_WIN95   (BOOL)(!(IS_NT) && !(IS_WIN32S)) && IS_WIN32

HINSTANCE hInst;   // current instance

LPCTSTR lpszAppName = "MyApp";
LPCTSTR lpszTitle   = "SQLParamOptions()"; 


BOOL RegisterWin95( CONST WNDCLASS* lpwc );


int APIENTRY WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
                      LPTSTR lpCmdLine, int nCmdShow)
{
   MSG      msg;
   HWND     hWnd; 
   WNDCLASS wc;

   wc.style         = CS_HREDRAW | CS_VREDRAW;
   wc.lpfnWndProc   = (WNDPROC)WndProc;       
   wc.cbClsExtra    = 0;                      
   wc.cbWndExtra    = 0;                      
   wc.hInstance     = hInstance;              
   wc.hIcon         = LoadIcon (hInstance, lpszAppName); 
   wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
   wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
   wc.lpszMenuName  = lpszAppName;              
   wc.lpszClassName = lpszAppName;              

   if ( IS_WIN95 )
   {
      if ( !RegisterWin95( &wc ) )
         return( FALSE );
   }
   else if ( !RegisterClass( &wc ) )
      return( FALSE );

   hInst = hInstance; 

   hWnd = CreateWindow( lpszAppName, 
                        lpszTitle,    
                        WS_OVERLAPPEDWINDOW, 
                        CW_USEDEFAULT, 0, 
                        CW_USEDEFAULT, 0,  
                        NULL,              
                        NULL,              
                        hInstance,         
                        NULL               
                      );

   if ( !hWnd ) 
      return( FALSE );

   ShowWindow( hWnd, nCmdShow ); 
   UpdateWindow( hWnd );         

   while( GetMessage( &msg, NULL, 0, 0) )   
   {
      TranslateMessage( &msg ); 
      DispatchMessage( &msg );  
   }

   return( msg.wParam ); 
}


BOOL RegisterWin95( CONST WNDCLASS* lpwc )
{
   WNDCLASSEX wcex;

   wcex.style         = lpwc->style;
   wcex.lpfnWndProc   = lpwc->lpfnWndProc;
   wcex.cbClsExtra    = lpwc->cbClsExtra;
   wcex.cbWndExtra    = lpwc->cbWndExtra;
   wcex.hInstance     = lpwc->hInstance;
   wcex.hIcon         = lpwc->hIcon;
   wcex.hCursor       = lpwc->hCursor;
   wcex.hbrBackground = lpwc->hbrBackground;
   wcex.lpszMenuName  = lpwc->lpszMenuName;
   wcex.lpszClassName = lpwc->lpszClassName;

   // Added elements for Windows 95.
   //...............................
   wcex.cbSize = sizeof(WNDCLASSEX);
   wcex.hIconSm = LoadImage(wcex.hInstance, lpwc->lpszClassName, 
                            IMAGE_ICON, 16, 16,
                            LR_DEFAULTCOLOR );
			
   return RegisterClassEx( &wcex );
}


// buffer lengths
// ..............
#define NAME_LEN 20

LRESULT CALLBACK WndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
static HENV  hEnv  = NULL;
static HDBC  hDBC  = NULL;
static HWND  hList = NULL;
static PTR   pParamData;

static UCHAR szSqlStr[] = 
   "Insert into department( dept_id, dept_name, dept_head_id ) "
   "Values ( ?, ?, ? )";
static UCHAR szLBStr[128];

// data being sent to the employee table.
// ......................................

static int   nDeptId    [3]             = { 600,          700,          800          };
static UCHAR sDeptName  [3][NAME_LEN+1] = { "Accounting", "Accounting", "Recruiting" };
static int   nDeptHeadId[3]             = { 501,          703,          703          };

static SDWORD cbIdLen    [3];
static SDWORD cbNameLen  [3];
static SDWORD cbHeadIdLen[3];

   switch( uMsg )
   {
      case WM_CREATE :
              {
                 RETCODE retCode;

                 // Allocate Environment and Connection.
                 //.....................................
                 SQLAllocEnv( &hEnv );
                 SQLAllocConnect( hEnv, &hDBC );

                 // Connect to the data source
                 //...........................
                 retCode = SQLConnect( hDBC, 
                             "Test Data Source", SQL_NTS,
                             "DBA",              SQL_NTS,  
                             "SQL",              SQL_NTS );

                 if ( retCode != SQL_SUCCESS )
                 {
                    SQLFreeConnect( hDBC );
                    SQLFreeEnv( hEnv );
                    return( -1 );
                 }

                 if ( retCode == SQL_SUCCESS )
                 {
                    hList = CreateWindow( "LISTBOX", "",    
                                          LBS_NOTIFY | WS_VSCROLL | 
                                          WS_BORDER  | WS_CHILD | 
                                          WS_VISIBLE | LBS_NOINTEGRALHEIGHT, 
                                          0, 0, 
                                          0, 0,  
                                          hWnd,              
                                          (HMENU)101,              
                                          hInst,         
                                          NULL               
                                        );
                 }
              }
              break;

      case WM_SIZE :
              MoveWindow( hList, 0, 0, LOWORD( lParam ), 
                                       HIWORD( lParam ), TRUE );
              break; 
              
      case WM_COMMAND :
              switch( LOWORD( wParam ) )
              {
                 case IDM_TEST :
                        {
                           HSTMT   hStmt;
                           RETCODE retCode;
                           int     i = 0;
                           UDWORD  iRow = 0L;

                           // Allocate a statement handle for the query.
                           // ..........................................
                           SQLAllocStmt( hDBC, &hStmt );

                           // Call SQLPrepare() to compile the query.
                           // .......................................
                           retCode = SQLPrepare( hStmt, szSqlStr, SQL_NTS );
                           
                           if( retCode != SQL_SUCCESS && 
                               retCode != SQL_SUCCESS_WITH_INFO )
                           {
                              SQLFreeStmt( hStmt, SQL_DROP );
                              break;
                           }
                           
                           // Call SQLBindParameter() to 
                           // bind buffers for the columns.
                           // .............................
                           SQLBindParameter( hStmt, 1, SQL_PARAM_INPUT, 
                                             SQL_C_DEFAULT, SQL_INTEGER,
                                             0, 0, 
                                             nDeptId, 0,
                                             cbIdLen );
                           
                           SQLBindParameter( hStmt, 2, SQL_PARAM_INPUT, 
                                             SQL_C_CHAR, SQL_CHAR, 
                                             NAME_LEN, 0, 
                                             sDeptName, sizeof(sDeptName),  
                                             cbNameLen );

                           SQLBindParameter( hStmt, 3, SQL_PARAM_INPUT, 
                                             SQL_C_DEFAULT, SQL_INTEGER, 
                                             0, 0, 
                                             nDeptHeadId, 0,
                                             cbHeadIdLen );
                           
                           
                           // Use SQLParamOptions() to specify passage of 
                           // three parameters to the statement handle.
                           // ...........................................
                           SQLParamOptions( hStmt, 3, &iRow );

                           // Call SQLExecute() to execute the query.
                           // .......................................
                           retCode = SQLExecute( hStmt );

                           // Error handling.
                           // ...............
                           while( retCode != SQL_SUCCESS && 
                                  retCode != SQL_SUCCESS_WITH_INFO )
                           {
                              char szLBStr[128];

                              // If iRow remains unchanged, the query 
                              // failed, so rollback the transaction and
                              // quit processing.
                              //
                              // If iRow == 1, the  first row failed, 
                              // rollback the transaction and terminate
                              // processing.
                              // .......................................
                              if( iRow == 0 || iRow == 1 )
                              {
                                 // Rollback the transaction.
                                 // .........................
                                 SQLTransact( SQL_NULL_HENV, hDBC,
                                              SQL_ROLLBACK);

                                 SendMessage( hList, LB_ADDSTRING, 
                                    0, (LPARAM)"Inserts failed." );

                                 break;
                              }

                              // Attempt to process the remaining records.
                              // .........................................
                              sprintf( szLBStr, "Insert of row %ld failed.",
                                                 iRow );

                              SendMessage( hList, LB_ADDSTRING, 
                                           0, (LPARAM)szLBStr );

                              // Rebind parameters.
                              // ..................

                              SQLBindParameter( hStmt, 1, SQL_PARAM_INPUT, 
                                                SQL_C_DEFAULT, SQL_INTEGER,
                                                0, 0, 
                                                &nDeptId[iRow], 0,
                                                &cbIdLen[iRow] );
                           
                              SQLBindParameter( hStmt, 2, SQL_PARAM_INPUT, 
                                                SQL_C_CHAR, SQL_CHAR, 
                                                NAME_LEN, 0, 
                                                &sDeptName[iRow], sizeof(sDeptName),  
                                                &cbNameLen[iRow] );

                              SQLBindParameter( hStmt, 3, SQL_PARAM_INPUT, 
                                                SQL_C_DEFAULT, SQL_INTEGER, 
                                                0, 0, 
                                                &nDeptHeadId[iRow], 0,
                                                &cbHeadIdLen[iRow] );


                              // Reset parameter options
                              // with SQLParamOptions().
                              // .......................
                              SQLParamOptions( hStmt, 3-iRow, &iRow );

                              // Call SQLExecute() to insert 
                              // the remaining rows.
                              // ...........................
                              retCode = SQLExecute( hStmt );
                           }

                           if( retCode == SQL_SUCCESS || 
                               retCode == SQL_SUCCESS_WITH_INFO )
                           {
                              // Commit the transaction.
                              // .......................
                              SQLTransact( SQL_NULL_HENV, hDBC, SQL_COMMIT );

                              SendMessage( hList, LB_ADDSTRING, 
                                           0, (LPARAM)"Inserts successful." );
                           }
                           
                           // Free the statement handle.
                           // ..........................
                           SQLFreeStmt( hStmt, SQL_DROP );
                        }
                        break;

                 case IDM_ABOUT :
                        DialogBox( hInst, "AboutBox", hWnd, (DLGPROC)About );
                        break;

                 case IDM_EXIT :
                        DestroyWindow( hWnd );
                        break;
              }
              break;
      
      case WM_DESTROY :
              PostQuitMessage(0);

              // Disconnect Environment.
              //........................
              SQLDisconnect( hDBC );

              // Free Connection and Environment.
              //.................................
              SQLFreeConnect( hDBC );
              SQLFreeEnv( hEnv );
              break;

      default :
            return( DefWindowProc( hWnd, uMsg, wParam, lParam ) );
   }

   return( 0L );
}

LRESULT CALLBACK About( HWND hDlg,           
                        UINT message,        
                        WPARAM wParam,       
                        LPARAM lParam)
{
   switch (message) 
   {
       case WM_INITDIALOG: 
               return (TRUE);

       case WM_COMMAND:                              
               if (   LOWORD(wParam) == IDOK         
                   || LOWORD(wParam) == IDCANCEL)    
               {
                       EndDialog(hDlg, TRUE);        
                       return (TRUE);
               }
               break;
   }

   return (FALSE); 
}
